branch: add test for -m renaming multiple config sections
[git.git] / git-submodule.sh
blobc0d0e9a4c63495d4522666b6edf984c01c0cfa23
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17 OPTIONS_SPEC=
18 SUBDIRECTORY_OK=Yes
19 . git-sh-setup
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
30 command=
31 branch=
32 force=
33 reference=
34 cached=
35 recursive=
36 init=
37 files=
38 remote=
39 nofetch=
40 update=
41 prefix=
42 custom_name=
43 depth=
44 progress=
46 die_if_unmatched ()
48 if test "$1" = "#unmatched"
49 then
50 exit ${2:-1}
55 # Print a submodule configuration setting
57 # $1 = submodule name
58 # $2 = option name
59 # $3 = default value
61 # Checks in the usual git-config places first (for overrides),
62 # otherwise it falls back on .gitmodules. This allows you to
63 # distribute project-wide defaults in .gitmodules, while still
64 # customizing individual repositories if necessary. If the option is
65 # not in .gitmodules either, print a default value.
67 get_submodule_config () {
68 name="$1"
69 option="$2"
70 default="$3"
71 value=$(git config submodule."$name"."$option")
72 if test -z "$value"
73 then
74 value=$(git config -f .gitmodules submodule."$name"."$option")
76 printf '%s' "${value:-$default}"
79 isnumber()
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
84 # Sanitize the local git environment for use within a submodule. We
85 # can't simply use clear_local_git_env since we want to preserve some
86 # of the settings from GIT_CONFIG_PARAMETERS.
87 sanitize_submodule_env()
89 save_config=$GIT_CONFIG_PARAMETERS
90 clear_local_git_env
91 GIT_CONFIG_PARAMETERS=$save_config
92 export GIT_CONFIG_PARAMETERS
96 # Add a new submodule to the working tree, .gitmodules and the index
98 # $@ = repo path
100 # optional branch is stored in global branch variable
102 cmd_add()
104 # parse $args after "submodule ... add".
105 reference_path=
106 while test $# -ne 0
108 case "$1" in
109 -b | --branch)
110 case "$2" in '') usage ;; esac
111 branch=$2
112 shift
114 -f | --force)
115 force=$1
117 -q|--quiet)
118 GIT_QUIET=1
120 --reference)
121 case "$2" in '') usage ;; esac
122 reference_path=$2
123 shift
125 --reference=*)
126 reference_path="${1#--reference=}"
128 --name)
129 case "$2" in '') usage ;; esac
130 custom_name=$2
131 shift
133 --depth)
134 case "$2" in '') usage ;; esac
135 depth="--depth=$2"
136 shift
138 --depth=*)
139 depth=$1
142 shift
143 break
146 usage
149 break
151 esac
152 shift
153 done
155 if test -n "$reference_path"
156 then
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
160 reference="--reference=$reference_path"
163 repo=$1
164 sm_path=$2
166 if test -z "$sm_path"; then
167 sm_path=$(printf '%s\n' "$repo" |
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
171 if test -z "$repo" || test -z "$sm_path"; then
172 usage
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
177 # assure repo is absolute or relative to parent
178 case "$repo" in
179 ./*|../*)
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
183 # dereference source url relative to parent's url
184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
186 *:*|/*)
187 # absolute url
188 realrepo=$repo
191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
193 esac
195 # normalize path:
196 # multiple //; leading ./; /./; /../; trailing /
197 sm_path=$(printf '%s/\n' "$sm_path" |
198 sed -e '
199 s|//*|/|g
200 s|^\(\./\)*||
201 s|/\(\./\)*|/|g
202 :start
203 s|\([^/]*\)/\.\./||
204 tstart
205 s|/*$||
207 if test -z "$force"
208 then
209 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210 die "$(eval_gettext "'\$sm_path' already exists in the index")"
211 else
212 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
216 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
217 then
218 eval_gettextln "The following path is ignored by one of your .gitignore files:
219 \$sm_path
220 Use -f if you really want to add it." >&2
221 exit 1
224 if test -n "$custom_name"
225 then
226 sm_name="$custom_name"
227 else
228 sm_name="$sm_path"
231 # perhaps the path exists and is already a git repo, else clone it
232 if test -e "$sm_path"
233 then
234 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
235 then
236 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
237 else
238 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
241 else
242 if test -d ".git/modules/$sm_name"
243 then
244 if test -z "$force"
245 then
246 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
247 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
248 die "$(eval_gettextln "\
249 If you want to reuse this local git directory instead of cloning again from
250 \$realrepo
251 use the '--force' option. If the local git directory is not the correct repo
252 or you are unsure what this means choose another name with the '--name' option.")"
253 else
254 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
257 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
259 sanitize_submodule_env
260 cd "$sm_path" &&
261 # ash fails to wordsplit ${branch:+-b "$branch"...}
262 case "$branch" in
263 '') git checkout -f -q ;;
264 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
265 esac
266 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
268 git config submodule."$sm_name".url "$realrepo"
270 git add $force "$sm_path" ||
271 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
273 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
274 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
275 if test -n "$branch"
276 then
277 git config -f .gitmodules submodule."$sm_name".branch "$branch"
278 fi &&
279 git add --force .gitmodules ||
280 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
282 # NEEDSWORK: In a multi-working-tree world, this needs to be
283 # set in the per-worktree config.
284 if git config --get submodule.active >/dev/null
285 then
286 # If the submodule being adding isn't already covered by the
287 # current configured pathspec, set the submodule's active flag
288 if ! git submodule--helper is-active "$sm_path"
289 then
290 git config submodule."$sm_name".active "true"
292 else
293 git config submodule."$sm_name".active "true"
298 # Execute an arbitrary command sequence in each checked out
299 # submodule
301 # $@ = command to execute
303 cmd_foreach()
305 # parse $args after "submodule ... foreach".
306 while test $# -ne 0
308 case "$1" in
309 -q|--quiet)
310 GIT_QUIET=1
312 --recursive)
313 recursive=1
316 usage
319 break
321 esac
322 shift
323 done
325 toplevel=$(pwd)
327 # dup stdin so that it can be restored when running the external
328 # command in the subshell (and a recursive call to this function)
329 exec 3<&0
332 git submodule--helper list --prefix "$wt_prefix" ||
333 echo "#unmatched" $?
335 while read -r mode sha1 stage sm_path
337 die_if_unmatched "$mode" "$sha1"
338 if test -e "$sm_path"/.git
339 then
340 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
341 say "$(eval_gettext "Entering '\$displaypath'")"
342 name=$(git submodule--helper name "$sm_path")
344 prefix="$prefix$sm_path/"
345 sanitize_submodule_env
346 cd "$sm_path" &&
347 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
348 # we make $path available to scripts ...
349 path=$sm_path &&
350 if test $# -eq 1
351 then
352 eval "$1"
353 else
354 "$@"
355 fi &&
356 if test -n "$recursive"
357 then
358 cmd_foreach "--recursive" "$@"
360 ) <&3 3<&- ||
361 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
363 done
367 # Register submodules in .git/config
369 # $@ = requested paths (default to all)
371 cmd_init()
373 # parse $args after "submodule ... init".
374 while test $# -ne 0
376 case "$1" in
377 -q|--quiet)
378 GIT_QUIET=1
381 shift
382 break
385 usage
388 break
390 esac
391 shift
392 done
394 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
398 # Unregister submodules from .git/config and remove their work tree
400 cmd_deinit()
402 # parse $args after "submodule ... deinit".
403 deinit_all=
404 while test $# -ne 0
406 case "$1" in
407 -f|--force)
408 force=$1
410 -q|--quiet)
411 GIT_QUIET=1
413 --all)
414 deinit_all=t
417 shift
418 break
421 usage
424 break
426 esac
427 shift
428 done
430 if test -n "$deinit_all" && test "$#" -ne 0
431 then
432 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
433 usage
435 if test $# = 0 && test -z "$deinit_all"
436 then
437 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
441 git submodule--helper list --prefix "$wt_prefix" "$@" ||
442 echo "#unmatched" $?
444 while read -r mode sha1 stage sm_path
446 die_if_unmatched "$mode" "$sha1"
447 name=$(git submodule--helper name "$sm_path") || exit
449 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
451 # Remove the submodule work tree (unless the user already did it)
452 if test -d "$sm_path"
453 then
454 # Protect submodules containing a .git directory
455 if test -d "$sm_path/.git"
456 then
457 die "$(eval_gettext "\
458 Submodule work tree '\$displaypath' contains a .git directory
459 (use 'rm -rf' if you really want to remove it including all of its history)")"
462 if test -z "$force"
463 then
464 git rm -qn "$sm_path" ||
465 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
467 rm -rf "$sm_path" &&
468 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
469 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
472 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
474 # Remove the .git/config entries (unless the user already did it)
475 if test -n "$(git config --get-regexp submodule."$name\.")"
476 then
477 # Remove the whole section so we have a clean state when
478 # the user later decides to init this submodule again
479 url=$(git config submodule."$name".url)
480 git config --remove-section submodule."$name" 2>/dev/null &&
481 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
483 done
486 is_tip_reachable () (
487 sanitize_submodule_env &&
488 cd "$1" &&
489 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
490 test -z "$rev"
493 fetch_in_submodule () (
494 sanitize_submodule_env &&
495 cd "$1" &&
496 case "$2" in
498 git fetch ;;
500 shift
501 git fetch $(get_default_remote) "$@" ;;
502 esac
506 # Update each submodule path to correct revision, using clone and checkout as needed
508 # $@ = requested paths (default to all)
510 cmd_update()
512 # parse $args after "submodule ... update".
513 while test $# -ne 0
515 case "$1" in
516 -q|--quiet)
517 GIT_QUIET=1
519 --progress)
520 progress="--progress"
522 -i|--init)
523 init=1
525 --remote)
526 remote=1
528 -N|--no-fetch)
529 nofetch=1
531 -f|--force)
532 force=$1
534 -r|--rebase)
535 update="rebase"
537 --reference)
538 case "$2" in '') usage ;; esac
539 reference="--reference=$2"
540 shift
542 --reference=*)
543 reference="$1"
545 -m|--merge)
546 update="merge"
548 --recursive)
549 recursive=1
551 --checkout)
552 update="checkout"
554 --recommend-shallow)
555 recommend_shallow="--recommend-shallow"
557 --no-recommend-shallow)
558 recommend_shallow="--no-recommend-shallow"
560 --depth)
561 case "$2" in '') usage ;; esac
562 depth="--depth=$2"
563 shift
565 --depth=*)
566 depth=$1
568 -j|--jobs)
569 case "$2" in '') usage ;; esac
570 jobs="--jobs=$2"
571 shift
573 --jobs=*)
574 jobs=$1
577 shift
578 break
581 usage
584 break
586 esac
587 shift
588 done
590 if test -n "$init"
591 then
592 cmd_init "--" "$@" || return
596 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
597 ${progress:+"$progress"} \
598 ${wt_prefix:+--prefix "$wt_prefix"} \
599 ${prefix:+--recursive-prefix "$prefix"} \
600 ${update:+--update "$update"} \
601 ${reference:+"$reference"} \
602 ${depth:+--depth "$depth"} \
603 ${recommend_shallow:+"$recommend_shallow"} \
604 ${jobs:+$jobs} \
605 "$@" || echo "#unmatched" $?
606 } | {
607 err=
608 while read -r mode sha1 stage just_cloned sm_path
610 die_if_unmatched "$mode" "$sha1"
612 name=$(git submodule--helper name "$sm_path") || exit
613 url=$(git config submodule."$name".url)
614 if ! test -z "$update"
615 then
616 update_module=$update
617 else
618 update_module=$(git config submodule."$name".update)
619 if test -z "$update_module"
620 then
621 update_module="checkout"
625 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
627 if test $just_cloned -eq 1
628 then
629 subsha1=
630 case "$update_module" in
631 merge | rebase | none)
632 update_module=checkout ;;
633 esac
634 else
635 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
636 git rev-parse --verify HEAD) ||
637 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
640 if test -n "$remote"
641 then
642 branch=$(git submodule--helper remote-branch "$sm_path")
643 if test -z "$nofetch"
644 then
645 # Fetch remote before determining tracking $sha1
646 fetch_in_submodule "$sm_path" $depth ||
647 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
649 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
650 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
651 git rev-parse --verify "${remote_name}/${branch}") ||
652 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
655 if test "$subsha1" != "$sha1" || test -n "$force"
656 then
657 subforce=$force
658 # If we don't already have a -f flag and the submodule has never been checked out
659 if test -z "$subsha1" && test -z "$force"
660 then
661 subforce="-f"
664 if test -z "$nofetch"
665 then
666 # Run fetch only if $sha1 isn't present or it
667 # is not reachable from a ref.
668 is_tip_reachable "$sm_path" "$sha1" ||
669 fetch_in_submodule "$sm_path" $depth ||
670 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
672 # Now we tried the usual fetch, but $sha1 may
673 # not be reachable from any of the refs
674 is_tip_reachable "$sm_path" "$sha1" ||
675 fetch_in_submodule "$sm_path" $depth "$sha1" ||
676 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
679 must_die_on_failure=
680 case "$update_module" in
681 checkout)
682 command="git checkout $subforce -q"
683 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
684 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
686 rebase)
687 command="git rebase"
688 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
689 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
690 must_die_on_failure=yes
692 merge)
693 command="git merge"
694 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
695 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
696 must_die_on_failure=yes
699 command="${update_module#!}"
700 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
701 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
702 must_die_on_failure=yes
705 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
706 esac
708 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
709 then
710 say "$say_msg"
711 elif test -n "$must_die_on_failure"
712 then
713 die_with_status 2 "$die_msg"
714 else
715 err="${err};$die_msg"
716 continue
720 if test -n "$recursive"
721 then
723 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
724 wt_prefix=
725 sanitize_submodule_env
726 cd "$sm_path" &&
727 eval cmd_update
729 res=$?
730 if test $res -gt 0
731 then
732 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
733 if test $res -ne 2
734 then
735 err="${err};$die_msg"
736 continue
737 else
738 die_with_status $res "$die_msg"
742 done
744 if test -n "$err"
745 then
746 OIFS=$IFS
747 IFS=';'
748 for e in $err
750 if test -n "$e"
751 then
752 echo >&2 "$e"
754 done
755 IFS=$OIFS
756 exit 1
761 set_name_rev () {
762 revname=$( (
763 sanitize_submodule_env
764 cd "$1" && {
765 git describe "$2" 2>/dev/null ||
766 git describe --tags "$2" 2>/dev/null ||
767 git describe --contains "$2" 2>/dev/null ||
768 git describe --all --always "$2"
771 test -z "$revname" || revname=" ($revname)"
774 # Show commit summary for submodules in index or working tree
776 # If '--cached' is given, show summary between index and given commit,
777 # or between working tree and given commit
779 # $@ = [commit (default 'HEAD'),] requested paths (default all)
781 cmd_summary() {
782 summary_limit=-1
783 for_status=
784 diff_cmd=diff-index
786 # parse $args after "submodule ... summary".
787 while test $# -ne 0
789 case "$1" in
790 --cached)
791 cached="$1"
793 --files)
794 files="$1"
796 --for-status)
797 for_status="$1"
799 -n|--summary-limit)
800 summary_limit="$2"
801 isnumber "$summary_limit" || usage
802 shift
804 --summary-limit=*)
805 summary_limit="${1#--summary-limit=}"
806 isnumber "$summary_limit" || usage
809 shift
810 break
813 usage
816 break
818 esac
819 shift
820 done
822 test $summary_limit = 0 && return
824 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
825 then
826 head=$rev
827 test $# = 0 || shift
828 elif test -z "$1" || test "$1" = "HEAD"
829 then
830 # before the first commit: compare with an empty tree
831 head=$(git hash-object -w -t tree --stdin </dev/null)
832 test -z "$1" || shift
833 else
834 head="HEAD"
837 if [ -n "$files" ]
838 then
839 test -n "$cached" &&
840 die "$(gettext "The --cached option cannot be used with the --files option")"
841 diff_cmd=diff-files
842 head=
845 cd_to_toplevel
846 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
847 # Get modified modules cared by user
848 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
849 sane_egrep '^:([0-7]* )?160000' |
850 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
852 # Always show modules deleted or type-changed (blob<->module)
853 if test "$status" = D || test "$status" = T
854 then
855 printf '%s\n' "$sm_path"
856 continue
858 # Respect the ignore setting for --for-status.
859 if test -n "$for_status"
860 then
861 name=$(git submodule--helper name "$sm_path")
862 ignore_config=$(get_submodule_config "$name" ignore none)
863 test $status != A && test $ignore_config = all && continue
865 # Also show added or modified modules which are checked out
866 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
867 printf '%s\n' "$sm_path"
868 done
871 test -z "$modules" && return
873 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
874 sane_egrep '^:([0-7]* )?160000' |
875 cut -c2- |
876 while read -r mod_src mod_dst sha1_src sha1_dst status name
878 if test -z "$cached" &&
879 test $sha1_dst = 0000000000000000000000000000000000000000
880 then
881 case "$mod_dst" in
882 160000)
883 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
885 100644 | 100755 | 120000)
886 sha1_dst=$(git hash-object $name)
888 000000)
889 ;; # removed
891 # unexpected type
892 eval_gettextln "unexpected mode \$mod_dst" >&2
893 continue ;;
894 esac
896 missing_src=
897 missing_dst=
899 test $mod_src = 160000 &&
900 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
901 missing_src=t
903 test $mod_dst = 160000 &&
904 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
905 missing_dst=t
907 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
909 total_commits=
910 case "$missing_src,$missing_dst" in
912 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
915 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
917 t,t)
918 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
921 errmsg=
922 total_commits=$(
923 if test $mod_src = 160000 && test $mod_dst = 160000
924 then
925 range="$sha1_src...$sha1_dst"
926 elif test $mod_src = 160000
927 then
928 range=$sha1_src
929 else
930 range=$sha1_dst
932 GIT_DIR="$name/.git" \
933 git rev-list --first-parent $range -- | wc -l
935 total_commits=" ($(($total_commits + 0)))"
937 esac
939 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
940 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
941 if test $status = T
942 then
943 blob="$(gettext "blob")"
944 submodule="$(gettext "submodule")"
945 if test $mod_dst = 160000
946 then
947 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
948 else
949 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
951 else
952 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
954 if test -n "$errmsg"
955 then
956 # Don't give error msg for modification whose dst is not submodule
957 # i.e. deleted or changed to blob
958 test $mod_dst = 160000 && echo "$errmsg"
959 else
960 if test $mod_src = 160000 && test $mod_dst = 160000
961 then
962 limit=
963 test $summary_limit -gt 0 && limit="-$summary_limit"
964 GIT_DIR="$name/.git" \
965 git log $limit --pretty='format: %m %s' \
966 --first-parent $sha1_src...$sha1_dst
967 elif test $mod_dst = 160000
968 then
969 GIT_DIR="$name/.git" \
970 git log --pretty='format: > %s' -1 $sha1_dst
971 else
972 GIT_DIR="$name/.git" \
973 git log --pretty='format: < %s' -1 $sha1_src
975 echo
977 echo
978 done
981 # List all submodules, prefixed with:
982 # - submodule not initialized
983 # + different revision checked out
985 # If --cached was specified the revision in the index will be printed
986 # instead of the currently checked out revision.
988 # $@ = requested paths (default to all)
990 cmd_status()
992 # parse $args after "submodule ... status".
993 while test $# -ne 0
995 case "$1" in
996 -q|--quiet)
997 GIT_QUIET=1
999 --cached)
1000 cached=1
1002 --recursive)
1003 recursive=1
1006 shift
1007 break
1010 usage
1013 break
1015 esac
1016 shift
1017 done
1020 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1021 echo "#unmatched" $?
1023 while read -r mode sha1 stage sm_path
1025 die_if_unmatched "$mode" "$sha1"
1026 name=$(git submodule--helper name "$sm_path") || exit
1027 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1028 if test "$stage" = U
1029 then
1030 say "U$sha1 $displaypath"
1031 continue
1033 if ! git submodule--helper is-active "$sm_path" ||
1035 ! test -d "$sm_path"/.git &&
1036 ! test -f "$sm_path"/.git
1038 then
1039 say "-$sha1 $displaypath"
1040 continue;
1042 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1043 then
1044 set_name_rev "$sm_path" "$sha1"
1045 say " $sha1 $displaypath$revname"
1046 else
1047 if test -z "$cached"
1048 then
1049 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1051 set_name_rev "$sm_path" "$sha1"
1052 say "+$sha1 $displaypath$revname"
1055 if test -n "$recursive"
1056 then
1058 prefix="$displaypath/"
1059 sanitize_submodule_env
1060 wt_prefix=
1061 cd "$sm_path" &&
1062 eval cmd_status
1063 ) ||
1064 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1066 done
1069 # Sync remote urls for submodules
1070 # This makes the value for remote.$remote.url match the value
1071 # specified in .gitmodules.
1073 cmd_sync()
1075 while test $# -ne 0
1077 case "$1" in
1078 -q|--quiet)
1079 GIT_QUIET=1
1080 shift
1082 --recursive)
1083 recursive=1
1084 shift
1087 shift
1088 break
1091 usage
1094 break
1096 esac
1097 done
1098 cd_to_toplevel
1100 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1101 echo "#unmatched" $?
1103 while read -r mode sha1 stage sm_path
1105 die_if_unmatched "$mode" "$sha1"
1107 # skip inactive submodules
1108 if ! git submodule--helper is-active "$sm_path"
1109 then
1110 continue
1113 name=$(git submodule--helper name "$sm_path")
1114 url=$(git config -f .gitmodules --get submodule."$name".url)
1116 # Possibly a url relative to parent
1117 case "$url" in
1118 ./*|../*)
1119 # rewrite foo/bar as ../.. to find path from
1120 # submodule work tree to superproject work tree
1121 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1122 # guarantee a trailing /
1123 up_path=${up_path%/}/ &&
1124 # path from submodule work tree to submodule origin repo
1125 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1126 # path from superproject work tree to submodule origin repo
1127 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1130 sub_origin_url="$url"
1131 super_config_url="$url"
1133 esac
1135 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1136 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1137 git config submodule."$name".url "$super_config_url"
1139 if test -e "$sm_path"/.git
1140 then
1142 sanitize_submodule_env
1143 cd "$sm_path"
1144 remote=$(get_default_remote)
1145 git config remote."$remote".url "$sub_origin_url"
1147 if test -n "$recursive"
1148 then
1149 prefix="$prefix$sm_path/"
1150 eval cmd_sync
1154 done
1157 cmd_absorbgitdirs()
1159 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1162 # This loop parses the command line arguments to find the
1163 # subcommand name to dispatch. Parsing of the subcommand specific
1164 # options are primarily done by the subcommand implementations.
1165 # Subcommand specific options such as --branch and --cached are
1166 # parsed here as well, for backward compatibility.
1168 while test $# != 0 && test -z "$command"
1170 case "$1" in
1171 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1172 command=$1
1174 -q|--quiet)
1175 GIT_QUIET=1
1177 -b|--branch)
1178 case "$2" in
1180 usage
1182 esac
1183 branch="$2"; shift
1185 --cached)
1186 cached="$1"
1189 break
1192 usage
1195 break
1197 esac
1198 shift
1199 done
1201 # No command word defaults to "status"
1202 if test -z "$command"
1203 then
1204 if test $# = 0
1205 then
1206 command=status
1207 else
1208 usage
1212 # "-b branch" is accepted only by "add"
1213 if test -n "$branch" && test "$command" != add
1214 then
1215 usage
1218 # "--cached" is accepted only by "status" and "summary"
1219 if test -n "$cached" && test "$command" != status && test "$command" != summary
1220 then
1221 usage
1224 "cmd_$command" "$@"